#include "stdafx.h"
#include "NeMessenger.h"
#include "CallerInfoDlg.h"
#include "NeMessengerDlg.h"
#include "resource.h"

#define PROFILE_IMAGE_WIDTH		88
#define PROFILE_IMAGE_HEIGHT	108

// CCallerInfoDlg ȭ Դϴ.
IMPLEMENT_DYNAMIC(CCallerInfoDlg, CBaseDlgStyleOne)

CCallerInfoDlg::CCallerInfoDlg(CString strID, CString strTelNo, CWnd* pParent)
: CBaseDlgStyleOne(CCallerInfoDlg::IDD, pParent)
{
	m_pParentDlg = (CNeMessengerDlg *)pParent;
	m_strID = strID;
	m_strTelNo = strTelNo;
	m_pThread = NULL;
    m_nPort = 80;
    m_dwServiceType = 0;
	m_hInternetSession = NULL;
	m_hHttpConnection = NULL;
	m_hHttpFile = NULL;
	m_bAbort = FALSE;
	m_bSafeToClose = FALSE;
	m_strName = _T("");
	m_trid = 0;
	m_pWASActor = NULL;
}

CCallerInfoDlg::~CCallerInfoDlg()
{
	m_penBorder.DeleteObject();
	m_penImageBorder.DeleteObject();
}

void CCallerInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CBaseDlgStyleOne::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PICTURE_STATIC, m_stPicture);
	DDX_Control(pDX, IDC_NAME_STATIC, m_staticName);
	DDX_Control(pDX, IDC_PART_STATIC, m_staticPart);
	DDX_Control(pDX, IDC_POSITION_STATIC, m_staticPosition);
	DDX_Control(pDX, IDC_TEL_STATIC, m_staticWorkTel);
	DDX_Control(pDX, IDC_MOBILE_STATIC, m_staticCellPhone);
	DDX_Control(pDX, IDC_EXTENTION_STATIC, m_staticExtention);
	DDX_Control(pDX, IDOK, m_btnOK);	
}


BEGIN_MESSAGE_MAP(CCallerInfoDlg, CBaseDlgStyleOne)	
	ON_WM_PAINT()	
	ON_WM_DESTROY()
	ON_MESSAGE(WM_CI_HTTPDOWNLOAD_THREAD_FINISHED, OnThreadFinished)

	ON_BN_CLICKED(IDOK, &CCallerInfoDlg::OnBnClickedOk)
END_MESSAGE_MAP()

void CALLBACK CCallerInfoDlg::_OnStatusCallBack(HINTERNET hInternet, DWORD_PTR dwContext, DWORD dwInternetStatus, 
											 LPVOID lpvStatusInformation, DWORD dwStatusInformationLength)
{
	switch (dwInternetStatus)
	{
	case INTERNET_STATUS_RESOLVING_NAME:
		{
			TRACE(_T("INTERNET_STATUS_RESOLVING_NAME\n"));    
			break;
		}
	case INTERNET_STATUS_NAME_RESOLVED:
		{
			TRACE(_T("INTERNET_STATUS_NAME_RESOLVED\n"));    
			break;
		}
	case INTERNET_STATUS_CONNECTING_TO_SERVER:
		{
			TRACE(_T("INTERNET_STATUS_CONNECTING_TO_SERVER\n"));    
			break;
		}
	case INTERNET_STATUS_CONNECTED_TO_SERVER:
		{
			TRACE(_T("INTERNET_STATUS_CONNECTED_TO_SERVER\n"));    
			break;
		}
	case INTERNET_STATUS_REDIRECT:
		{
			TRACE(_T("INTERNET_STATUS_REDIRECT\n"));    
			break;
		}
	case INTERNET_STATUS_REQUEST_SENT:
		{
			TRACE(_T("INTERNET_STATUS_REQUEST_SENT\n"));    
			break;
		}
	case INTERNET_STATUS_REQUEST_COMPLETE:
		{
			TRACE(_T("INTERNET_STATUS_REQUEST_COMPLETE\n"));    
			break;
		}
	default:
		{
			break;
		}
	}
}

void CCallerInfoDlg::CloseAllInternetHandle()
{
	if (m_hHttpFile != NULL)
	{
		InternetCloseHandle(m_hHttpFile);
		m_hHttpFile = NULL;
	}

	if (m_hHttpConnection != NULL)
	{
		InternetCloseHandle(m_hHttpConnection);
		m_hHttpConnection = NULL;
	}

	if (m_hInternetSession != NULL)
	{
		InternetCloseHandle(m_hInternetSession);
		m_hInternetSession = NULL;
	}

	m_FileToWrite.Close();
}

void CCallerInfoDlg::DownloadThread()
{
	//Create the Internet session handle
	ASSERT(m_hInternetSession == NULL);
	m_hInternetSession = ::InternetOpen(AfxGetAppName(), INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);

	if (m_hInternetSession == NULL)
	{
		TRACE(_T("Failed in call to InternetOpen, Error:%d\n"), ::GetLastError());  //lint !e515  
		CloseAllInternetHandle();
		return;
	}

	//Should we exit the thread
	if (m_bAbort)
	{
		PostMessage(WM_CI_HTTPDOWNLOAD_THREAD_FINISHED);
		CloseAllInternetHandle();
		return;
	}  

	//Setup the status callback function
	if (::InternetSetStatusCallback(m_hInternetSession, _OnStatusCallBack) == INTERNET_INVALID_STATUS_CALLBACK)
	{
		TRACE(_T("Failed in call to InternetSetStatusCallback, Error:%d\n"), ::GetLastError());   
		CloseAllInternetHandle();
		return;
	}

	//Should we exit the thread
	if (m_bAbort)
	{
		PostMessage(WM_CI_HTTPDOWNLOAD_THREAD_FINISHED);
		CloseAllInternetHandle();
		return;
	}  

	//Make the connection to the HTTP server          
	ASSERT(m_hHttpConnection == NULL);
	m_hHttpConnection = ::InternetConnect(m_hInternetSession, m_sServer, m_nPort, _T(""), _T(""), m_dwServiceType, 0, (DWORD_PTR)this);

	if (m_hHttpConnection == NULL)
	{
		TRACE(_T("Failed in call to InternetConnect, Error:%d\n"), ::GetLastError());    
		CloseAllInternetHandle();
		return;
	}

	//Should we exit the thread
	if (m_bAbort)
	{
		PostMessage(WM_CI_HTTPDOWNLOAD_THREAD_FINISHED);
		CloseAllInternetHandle();
		return;
	}

	ASSERT(m_hHttpFile == NULL);
	m_hHttpFile = ::HttpOpenRequest(m_hHttpConnection, _T("GET"), m_sObject, NULL, NULL, NULL, INTERNET_FLAG_RELOAD | INTERNET_FLAG_DONT_CACHE, (DWORD_PTR)this);

	if (m_hHttpFile == NULL)
	{
		TRACE(_T("Failed in call to HttpOpenRequest, Error:%d\n"), ::GetLastError());    
		CloseAllInternetHandle();
		return;
	}

	//Should we exit the thread
	if (m_bAbort)
	{
		PostMessage(WM_CI_HTTPDOWNLOAD_THREAD_FINISHED);
		CloseAllInternetHandle();
		return;
	}  

	//label used to jump to if we need to resend the request
resend:

	//Issue the request
	BOOL bSend = ::HttpSendRequest(m_hHttpFile, NULL, 0, NULL, 0);
	if (!bSend)
	{
		TRACE(_T("Failed in call to HttpSendRequest, Error:%d\n"), ::GetLastError());    
		CloseAllInternetHandle();
		return;
	}

	//Check the HTTP status code
	TCHAR szStatusCode[32] = {0,};
	DWORD dwInfoSize = 32;

	if (!::HttpQueryInfo(m_hHttpFile, HTTP_QUERY_STATUS_CODE, szStatusCode, &dwInfoSize, NULL))
	{
		TRACE(_T("Failed in call to HttpQueryInfo for HTTP query status code, Error:%d\n"), ::GetLastError());    
		CloseAllInternetHandle();
		return;
	}
	else
	{
		long nStatusCode = _ttol(szStatusCode);

		//Handle any authentication errors
		if (nStatusCode == HTTP_STATUS_PROXY_AUTH_REQ || nStatusCode == HTTP_STATUS_DENIED)
		{
			// We have to read all outstanding data on the Internet handle
			// before we can resubmit request. Just discard the data.
			char szData[51];
			DWORD dwSize;
			do
			{
				::InternetReadFile(m_hHttpFile, (LPVOID)szData, 50, &dwSize);
			}
			while (dwSize != 0);

			//Bring up the standard authentication dialog
			if (::InternetErrorDlg(GetSafeHwnd(), m_hHttpFile, ERROR_INTERNET_INCORRECT_PASSWORD, FLAGS_ERROR_UI_FILTER_FOR_ERRORS |
				FLAGS_ERROR_UI_FLAGS_GENERATE_DATA | FLAGS_ERROR_UI_FLAGS_CHANGE_OPTIONS, NULL) == ERROR_INTERNET_FORCE_RETRY)
				goto resend;
		}
		else if (nStatusCode != HTTP_STATUS_OK)
		{
			TRACE(_T("Failed to retrieve a HTTP 200 status, Status Code:%d\n"), nStatusCode);      
			CloseAllInternetHandle();
			return;
		}
	}

	// Get the length of the file.
	TCHAR szContentLength[32] = {0,};
	dwInfoSize = 32;
	DWORD dwFileSize = 0;
	//BOOL bGotFileSize = FALSE;
	if (::HttpQueryInfo(m_hHttpFile, HTTP_QUERY_CONTENT_LENGTH, szContentLength, &dwInfoSize, NULL))
	{
		//Set the progress control range
		//bGotFileSize = TRUE;
		dwFileSize = (DWORD) _ttol(szContentLength);   
        TRACE(_T("FileSize=%d\n"), dwFileSize);      
	}
	else
	{
		TRACE(_T("Failed to HttpQueryInfo\n"));      
		CloseAllInternetHandle();
		return;
	}

	//Now do the actual read of the file
	DWORD dwBytesRead = 0;
	char szReadBuf[10240];
	DWORD dwBytesToRead = 10240;
	do
	{
		if (!::InternetReadFile(m_hHttpFile, szReadBuf, dwBytesToRead, &dwBytesRead))
		{
			TRACE(_T("Failed in call to InternetReadFile, Error:%d\n"), ::GetLastError());      
			CloseAllInternetHandle();
			return;
		}
		else if (dwBytesRead && !m_bAbort)
		{
			//Write the data to file
			TRY
			{
				m_FileToWrite.Write(szReadBuf, dwBytesRead);
			}
			CATCH(CFileException, e);                                          
			{
				TRACE(_T("An exception occured while writing to the download file\n"));        
				CloseAllInternetHandle();
				return;
			}
			END_CATCH

		}
	} 
	while (dwBytesRead && !m_bAbort);

	//Delete the file being downloaded to if it is present and the download was aborted
	if (m_bAbort)
		::DeleteFile(m_sFilename);

	CloseAllInternetHandle();

	//We're finished
	PostMessage(WM_CI_HTTPDOWNLOAD_THREAD_FINISHED);
}

LRESULT CCallerInfoDlg::OnThreadFinished(WPARAM wParam, LPARAM /*lParam*/)
{
	//It's now safe to close since the thread has signaled us
	m_bSafeToClose = TRUE;

	//If an error occured display the message box
	if (!m_bAbort && !wParam)
	{
		DrawProfileImage(m_sFilename);
	}

	::DeleteFile(m_sFilename);

	return 0L;
}

void CCallerInfoDlg::DrawProfileImage(CString &strImageFilePath)
{
	Image imgProfile(strImageFilePath);

	Bitmap bmpProfile(PROFILE_IMAGE_WIDTH, PROFILE_IMAGE_HEIGHT, PixelFormat32bppARGB);
	Graphics grpPhoto(&bmpProfile);

	RectF rcResize = GetFitSizeInRect(SizeF(PROFILE_IMAGE_WIDTH, PROFILE_IMAGE_HEIGHT), SizeF((Gdiplus::REAL)(imgProfile.GetWidth()), (Gdiplus::REAL)(imgProfile.GetHeight())));

	grpPhoto.DrawImage( &imgProfile, rcResize);

	HBITMAP hBmp;
	bmpProfile.GetHBITMAP(Gdiplus::Color(255, 255, 255), &hBmp);
	m_stPicture.SetBitmap(hBmp);
}

RectF CCallerInfoDlg::GetFitSizeInRect(const SizeF &sizeMax, const SizeF &sizeOrg)
{
	REAL fRatioW = sizeMax.Width / sizeOrg.Width;
	REAL fRatioH = sizeMax.Height / sizeOrg.Height;

	REAL fRatioResize = 1.0;
	if( fRatioW > fRatioH )
		fRatioResize = fRatioH;
	else
		fRatioResize = fRatioW;

	RectF rcResize;
	rcResize.Width = sizeOrg.Width * fRatioResize;
	rcResize.Height = sizeOrg.Height * fRatioResize;
	rcResize.X = (sizeMax.Width - rcResize.Width) / 2;
	rcResize.Y = (sizeMax.Height - rcResize.Height) / 2;

	return rcResize;
}

BOOL CCallerInfoDlg::OnInitDialog()
{
	CBaseDlgStyleOne::OnInitDialog();

	ModifyStyle(0, WS_CLIPCHILDREN);

	GT_MY_USER_DATA myUserData;
	g_pMessengerActor->GetMyUserInfo(myUserData);
	m_strMyID = myUserData.strUserID;

	SetWindowText(LoadStringFromResource(IDS_STRING584));

	InitControls();
	__ResourceLoad(TRUE);

	if (m_strID.IsEmpty())
	{
		m_stPicture.ShowWindow(SW_HIDE);
		m_staticName.ShowWindow(SW_HIDE);
		m_staticPart.ShowWindow(SW_HIDE);
		m_staticPosition.ShowWindow(SW_HIDE);
		m_staticExtention.ShowWindow(SW_HIDE);
		m_staticWorkTel.ShowWindow(SW_HIDE);
		m_staticCellPhone.ShowWindow(SW_HIDE);

		MoveWindow(0, 0, 400, 170);
	}
	else
	{
		//g_pMessengerActor->RegisterObserver(this);
		m_pWASActor = g_pMessengerActor->GetWASActor();
		m_pWASActor->RegisterObserver(this);

		vector<wstring> vecUsers;
		vecUsers.push_back(m_strID.GetBuffer());
		g_pMessengerActor->RequestRegiFavoriteToPOI(vecUsers, REGPOIGROUP_CALLERINFODLG);

		RequestInfo();

		MoveWindow(0, 0, 480, 345);
	}

	CenterWindow();

	return TRUE;
}

void CCallerInfoDlg::InitControls()
{
	m_stPicture.MoveWindow(20 - FRAME_WIDTH, 100, PROFILE_IMAGE_WIDTH, PROFILE_IMAGE_HEIGHT);	// 
	m_staticName.MoveWindow(210 - FRAME_WIDTH, 100, 250, 15);		// ̸
	m_staticPart.MoveWindow(210 - FRAME_WIDTH, 125, 250, 15);		// Ҽ
	m_staticPosition.MoveWindow(210 - FRAME_WIDTH, 150, 250, 15);	// /å
	m_staticExtention.MoveWindow(210 - FRAME_WIDTH, 175, 250, 15);	// ȣ
	m_staticWorkTel.MoveWindow(210 - FRAME_WIDTH, 200, 250, 15);	// ȸȭ
	m_staticCellPhone.MoveWindow(210 - FRAME_WIDTH, 225, 250, 15);	// ޴

	m_staticName.SetFont(&g_ftDefault10PTB);
	m_staticPart.SetFont(&g_ftDefault10PT);
	m_staticPosition.SetFont(&g_ftDefault10PT);
	m_staticWorkTel.SetFont(&g_ftDefault10PT);
	m_staticCellPhone.SetFont(&g_ftDefault10PT);
	m_staticExtention.SetFont(&g_ftDefault10PT);

	if (m_strID.IsEmpty())
		m_btnOK.MoveWindow(160, 104, 80, 30);
	else
		m_btnOK.MoveWindow(200, 279, 80, 30);
	m_btnOK.SetFont(&g_ftDefault10PT);

	// â  
	m_penBorder.CreatePen(PS_SOLID, 1, CI_COLOR_LIST_BORDER);
	m_penImageBorder.CreatePen(PS_SOLID, 1, CI_COLOR_IMAGE_BORDER);

	m_stPicture.SetBitmap(LoadImageFromPath(GetAppImgFile(_T("NoImage.bmp"))));
}

void CCallerInfoDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	NMMemDC memDC;
	memDC.CreateCompatibleDC(&dc, &rcClient);
	memDC.FillSolidRect(0, 0, rcClient.Width(), rcClient.Height(), CI_COLOR_NORMAL_BK);	// ȭ 

	CPen *pOldPen = memDC.SelectObject(&m_penBorder);
	memDC.SelectObject((HBRUSH)GetStockObject(NULL_BRUSH));

	//  μ
	memDC.MoveTo(0, 0);
	memDC.LineTo(rcClient.right, 0);

	// ϴ μ
	memDC.MoveTo(0, rcClient.bottom - 48);
	memDC.LineTo(rcClient.right, rcClient.bottom - 48);

	CFont *pOldFont = memDC.SelectObject(&g_ftDefault10PTB);
	memDC.SetTextColor(CI_COLOR_NORMAL_TEXT);

	if (m_strID.IsEmpty() || m_strName.IsEmpty())
	{
		CString strMsg;
		strMsg.Format(_T("%s %s."), m_strTelNo , LoadStringFromResource(IDS_STRING585));
		memDC.DrawText(strMsg, CRect(0, 40, rcClient.right, 70), DT_CENTER | DT_SINGLELINE | DT_NOPREFIX);	//  ȳ
	}
	else
	{
		// ߰ μ
		memDC.MoveTo(20 - FRAME_WIDTH, 75);
		memDC.LineTo(rcClient.right - 20 - FRAME_WIDTH, 75);

		CRect rcImage(0, 0, 0, 0);
		m_stPicture.GetWindowRect(&rcImage);
		this->ScreenToClient(rcImage);
		rcImage.InflateRect(1, 1, 1, 1);
		memDC.SelectObject(&m_penImageBorder);
		memDC.Rectangle(rcImage);

		CString strMsg;
		strMsg.Format(_T("%s %s."), m_strName, LoadStringFromResource(IDS_STRING586));

		memDC.DrawText(strMsg, CRect(0, 32, rcClient.right, 55), DT_CENTER | DT_SINGLELINE | DT_NOPREFIX);	//  ȳ

		memDC.SetTextColor(CI_COLOR_STATIC_TEXT);
		memDC.DrawText(LoadStringFromResource(IDS_STRING142), CRect(118 - FRAME_WIDTH, 100, 210, 125), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);	// ̸

		memDC.SelectObject(&g_ftDefault10PT);
		memDC.DrawText(LoadStringFromResource(IDS_STRING143), CRect(118 - FRAME_WIDTH, 125, 210, 150), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);	// Ҽ
		memDC.DrawText(LoadStringFromResource(IDS_STRING147), CRect(118 - FRAME_WIDTH, 150, 210, 175), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);	// /å
		memDC.DrawText(LoadStringFromResource(IDS_STRING270), CRect(118 - FRAME_WIDTH, 175, 210, 200), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);	// ȣ
		memDC.DrawText(LoadStringFromResource(IDS_STRING271), CRect(118 - FRAME_WIDTH, 200, 210, 225), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);	// ȸȭ
		memDC.DrawText(LoadStringFromResource(IDS_STRING272), CRect(118 - FRAME_WIDTH, 225, 210, 250), DT_LEFT | DT_SINGLELINE | DT_NOPREFIX);	// ޴
	}

	// memDC  ׸  ѹ DC ׷  .
	dc.BitBlt(0, 0, rcClient.Width(), rcClient.Height(), &memDC, 0, 0, SRCCOPY);

	memDC.SelectObject(pOldPen);
	memDC.SelectObject(pOldFont);
}

bool CCallerInfoDlg::OnGTWASActor_ResponseGetEmployeeInfo(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list, NTRequestEmpInfoType reqEmpInfoType, int nGroupID)
{	
	if (m_trid != trid)	//   trid  ƴϸ true Ͽ   óϵ ش.
		return true;

	if (eErrorCode != wasError_None)
		return false;

	for (size_t i = 0; i < list.nSize; i++) 
	{
		const NE_MEMBER_DATA &sMemberInfo = list.pList[i];
		m_userData = sMemberInfo;

		if (sMemberInfo.strUserId.c_str() != m_strID)
			continue; 

		CString strText;

		// ̸
		strText.Format(_T("%s"), sMemberInfo.strName.c_str());
		m_staticName.SetWindowText(strText);
		m_strName = strText;

		// Ҽ
		strText.Format(_T("%s"), sMemberInfo.strDept.c_str());
		m_staticPart.SetWindowText(strText);

		// /å
		strText.Format(_T("%s/%s"), sMemberInfo.strJobPos.c_str(), sMemberInfo.strJobDuty.c_str());
		m_staticPosition.SetWindowText(strText);

		//  ȣ
		strText.Format(_T("%s"), sMemberInfo.strExtesion.c_str());
		m_staticExtention.SetWindowText(strText);

		// ȸ ȣ
		strText.Format(_T("%s"), sMemberInfo.strIncoTel.c_str());
		m_staticWorkTel.SetWindowText(strText);

		// ޴
		strText.Format(_T("%s"), sMemberInfo.strCellPhone.c_str());
		m_staticCellPhone.SetWindowText(strText);

		// 
		if (sMemberInfo.strPhotoURL.empty() != true && (m_strID == m_strMyID || GET_CONFIG()->EnableFunction(_T("UI_02")) == TRUE))
		{
			DownloadPicture(sMemberInfo.strPhotoURL.c_str());
		}

	}
	
	Invalidate();

	return false;
}

void CCallerInfoDlg::OnDestroy()
{	
	__super::OnDestroy();

	g_pMessengerActor->RequestUregFavoriteFromPOI(REGPOIGROUP_CALLERINFODLG);

	//g_pMessengerActor->UnRegisterObserver(this);

	if (m_pWASActor)
		m_pWASActor->UnRegisterObserver(this);
}

void CCallerInfoDlg::RequestInfo(void)
{
	m_pWASActor->RequestEmplyeeInfo(m_strID, GetLanguageStringUnicode(), reitSingleTrans, &m_trid);
}

BOOL CCallerInfoDlg::PreTranslateMessage(MSG* pMsg)
{
	if (IsCloseMsg(pMsg))
	{
		OnCancel();
		return TRUE;
	}

	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_ESCAPE)
		{
			return TRUE;
		}
		else if (pMsg->wParam == VK_RETURN)
		{
			OnBnClickedOk();
			return TRUE;
		}
	}

	return __super::PreTranslateMessage(pMsg);
}

void CCallerInfoDlg::__ResourceLoad(BOOL bInit)
{
	if (bInit == FALSE)
		SendMessage(WM_SIZE, NULL, NULL);
}

void CCallerInfoDlg::SetReadOnly(BOOL bReadOnly)
{
	Invalidate();
}

//  ٿεϱ
void CCallerInfoDlg::DownloadPicture(CString strURL)
{	
	if (!AfxParseURL(strURL, m_dwServiceType, m_sServer, m_sObject, m_nPort))
	{
		//Try sticking "http://" before it
		strURL = _T("http://") + strURL;
		if (!AfxParseURL(strURL, m_dwServiceType, m_sServer, m_sObject, m_nPort))
		{
			TRACE(_T("Failed to parse the URL: %s\n"), strURL);

			return ;
		}
	}

	TCHAR lpTempPathBuffer[MAX_PATH];
	GetTempPath(MAX_PATH, lpTempPathBuffer);

	TCHAR szTempFileName[MAX_PATH];
	GetTempFileName(lpTempPathBuffer, TEXT("tmpntk"), 0, szTempFileName);
	m_sFilename = (LPTSTR)szTempFileName;

	if (!m_FileToWrite.Open(m_sFilename, CFile::modeCreate | CFile::modeWrite | CFile::shareDenyWrite))
	{	
		CString sError = _T("");
		sError.Format(_T("Failed CreateTmpFile: %d"), ::GetLastError());
		TRACE(_T("Failed CreateTmpFile: %s\n"), sError);
		//AfxMessageBox(sError);
		return ;
	}

	CWinThread* pThread = AfxBeginThread(_DownloadThread, this, THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED);
	if (pThread == NULL)
	{
		TRACE(_T("Failed to create download thread, dialog is aborting\n"));
		return ;
	}

	pThread->ResumeThread();

}

UINT CCallerInfoDlg::_DownloadThread(LPVOID pParam)
{
	//Convert from the SDK world to the C++ world
	CCallerInfoDlg* pDlg = (CCallerInfoDlg*) pParam;
	ASSERT(pDlg);
	ASSERT(pDlg->IsKindOf(RUNTIME_CLASS(CCallerInfoDlg)));

	if (pDlg == NULL)
		return 0;

	pDlg->DownloadThread();

	return 0;
}

bool CCallerInfoDlg::IsCloseMsg(MSG* pMsg)
{
	bool result = false;
	if (pMsg->message == WM_CLOSE ||
		(pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_F4) ||									// ALT + F4
		(pMsg->message == WM_SYSCOMMAND && (pMsg->wParam & 0xFFF0) == SC_CLOSE) ||						// ŸƲ Ŭ޴ > ݱ
		(pMsg->message == WM_COMMAND && HIWORD(pMsg->wParam) == 0 && LOWORD(pMsg->wParam) == IDCANCEL))	// Close button
	{
		result = true;
	}

	return result;
}

void CCallerInfoDlg::OnBnClickedOk()
{
	m_pParentDlg->OnTopMenuAnswerCall();
	//m_pParentDlg->CloseCallerInfoDlg();
}

void CCallerInfoDlg::OnCancel()
{
	//m_pParentDlg->CloseCallerInfoDlg();
}
